const mysql = require('mysql2/promise');

const createConnection = async () => {
	return await mysql.createConnection({
		host: 'chatntsi.com.br',
		user: 'chatntsi_ricardo',
		password: 'Perl1551@@@',
		database: 'chatntsicom_elari'
	});
}

const getStatus = async (msgfom) => {
	const connection = await createConnection();
	const [rows] = await connection.execute('SELECT status_bot FROM clientes WHERE chatId = ?', [msgfom]);
	if (rows.length > 0) return rows[0].status_bot;
	return false;
}
const getid_chat = async (msgfom) => {
	
	const connection = await createConnection();
	const [rows] = await connection.query('SELECT id_chat FROM clientes WHERE chatId = ?', [msgfom]);
	if (rows.length > 0) return rows[0].id_chat;
	
	return false;


	}
	
const atendente = async (msgfom,$solicitacao) => {
	   var dataAtual = new Date();
		const connection = await createConnection();
		const [rows] = await connection.execute('UPDATE clientes SET status = ?, solicitacao = ? WHERE chatId = ?', [dataAtual, $solicitacao,msgfom]);
		if (rows.length > 0) return rows[0].status_bot;
		return false;
	}

const setStatusOn = async (msgfom) => {
	const connection = await createConnection();
	const [rows] = await connection.execute('UPDATE clientes SET status_bot = "on" WHERE chatId = ?', [msgfom]);
	if (rows.length > 0) return rows[0].status_bot;
	return false;
}

const setStatusOff = async (msgfom) => {
	const connection = await createConnection();
	const [rows] = await connection.execute('UPDATE clientes SET status_bot = "off" WHERE chatId = ?', [msgfom]);
	if (rows.length > 0) return rows[0].status_bot;
	return false;
}

const getUser = async (msgfom) => {
	const connection = await createConnection();
	const [rows] = await connection.execute('SELECT chatId FROM clientes WHERE chatId = ?', [msgfom]);
	if (rows.length > 0) return true;
	return false;
}
const getatualiza = async (msgfom) => {
	const connection = await createConnection();
	const [rows] = await connection.execute('SELECT chatId FROM clientes WHERE  status <= NOW() - INTERVAL 600 MINUTE and chatId = ?', [msgfom]);
	if (rows.length > 0) return true;
	return false;
}

const setUser = async (msgfom) => {
	
	const padrao = "http://chatcorpobueno.com.br/imagens/padrao.png";
	var dataAtual = new Date();

	const connection = await createConnection(); 
  const consulta = await connection.execute('INSERT INTO clientes (id, status_bot, chatId, nome, foto, solicitacao, ultimo_status, empresa, autor,usuario,status) VALUES (NULL, "on", ?, "Sem_Nome", ?, "5", "5","1","1",?,?)', [msgfom,padrao,msgfom,dataAtual]); 
  
  const [rows] = await connection.query('SELECT id_chat FROM clientes WHERE chatId = ?', [msgfom]);
	if (rows.length > 0) return rows[0].id_chat;
	
	return false;
  
}

const setMensagem = async (msgfom,msgremetente,msgack,msgbody,msgtipo) => {
	
	const padrao = "http://chatcorpobueno.com.br/imagens/padrao.png";
	var dataAtual = new Date();
	const connection = await createConnection();
	const [rows] = await connection.execute('INSERT INTO mensagens (`id_de`,`id_para`,`mensagem`,`data`,`lido`,`tipo`,`comentario`,`tipo_comen`) VALUES (?, ?, ?, ?,"4",?, "comentario","chat")', [msgfom,msgfom,msgbody,dataAtual,msgtipo]);
	if (rows.length > 0) return rows[0].id_de;
	return false;
}
const cancela_disparo = async (msgfom) => {
	
	
	var dataAtual = new Date();
	const connection = await createConnection();
	const [rows] = await connection.execute('INSERT INTO cancela_disparo (`id`,`cliente`) VALUES (NULL, ?)', [msgfom]);
	if (rows.length > 0) return rows[0].id;
	return false;
}


const getReply = async (keyword) => {
	const connection = await createConnection();
	const [rows] = await connection.execute('SELECT resposta FROM bot WHERE pergunta = ?', [keyword]);
	if (rows.length > 0) return rows[0].resposta;
	return false;
}
const texto = async (keyword) => {
	const connection = await createConnection();
	const [rows] = await connection.execute('SELECT texto FROM campanha_geral WHERE api = ?', [keyword]);
	if (rows.length > 0) return rows[0].texto;
	return false;
}
const imagem = async (keyword) => {
	const connection = await createConnection();
	const [rows] = await connection.execute('SELECT imagem FROM campanha_geral WHERE api = ?', [keyword]);
	if (rows.length > 0) return rows[0].imagem;
	return false;
}

module.exports = {
	createConnection,
	setUser,
	getUser,
	getReply,
	getStatus,
	setStatusOn,
	setStatusOff,
	setMensagem,
	getid_chat,
	atendente,
	cancela_disparo,
	texto,
	imagem,
	getatualiza
}